//wifibot laurent@wifibot.com 
#ifndef WIFIBOT
#define WIFIBOT

//#include "stdafx.h"
#include <windows.h>
#include <strsafe.h>
#include <stdio.h>
#include <math.h>
#include <winsock.h>
#include "mutex.h"
#include "SharedMemory.h"
 
#pragma comment(lib,"ws2_32.lib")

#define BUF_SIZE 255
#define PORT_I2C_USB "COM5"
//#define debug_msg

#define I2CD_CMD	0x53		// direct I2C control command
#define I2C_CMD		0x55		// registered I2C control command
#define USBI2C_CMD	0x5a		// Module command 

enum cmds { nop=0, VERSION, NEW_ADDRESS, BATTERY,
			SCAN1, SCAN2, SCAN3, SCAN4, SCAN6, SCAN8, SCAN12, SCAN16,
			SETPINS=0x10, GETPINS, GETAD,
};

enum state { Done=0, Off, On };

HANDLE InitCom(int port,DWORD speed);
HANDLE SetupI2CCommPort(LPCSTR comport);
int GetFirmware(HANDLE hUSB);
struct SensorData GetI2cMotor(HANDLE hUSB, BYTE add);
int SetI2cMotor(HANDLE hUSB, BYTE add,BYTE speed);
int GetADC(HANDLE hUSB,BYTE add);
int StopMotor(HANDLE hUSB);

struct SensorData
	{
	int SpeedFront;
	int SpeedRear;
	int IR;
	int IR2;
	};

DWORD WINAPI Thread_TCP( LPVOID lpParam );
DWORD WINAPI Thread_TCP_Trooper_In( LPVOID lpParam );
DWORD WINAPI Thread_TCP_Trooper_Out( LPVOID lpParam );
DWORD WINAPI Thread_TCP_Trooper_I2C( LPVOID lpParam );
DWORD WINAPI Thread_Dog( LPVOID lpParam );
DWORD WINAPI Thread_TCP_I2C_Simu( LPVOID lpParam );

int init_I2C_USB(HANDLE hUSB);
int init_I2C_Simu(HANDLE hUSB);
int init_tcp_com(HANDLE hUSB);
int init_tcp_Trooper_com(HANDLE hUSB);

#endif 